function evert2(slide) {

var cutKS=true;
/*var inputKS1=document.getElementById("input2");
inputKS1.checked=false;
inputKS1.onchange=function () {
  cutKS=inputKS1.checked; 
};*/

var animateKS=false;
var inputKS2=document.getElementById("input3");
inputKS2.checked=false;
inputKS2.onchange=function () {
  animateKS=inputKS2.checked;
};

//var slide = document.getElementById(id);
var wi=slide.clientWidth-100;
var he=slide.clientHeight-100;

var sceneKS = new THREE.Scene();
var cameraKS = new THREE.PerspectiveCamera( 35, wi/he, 0.1, 1000 );
cameraKS.up.set(0,0,1);
cameraKS.position.set(0,7,0);
cameraKS.lookAt(new THREE.Vector3(0,0,0));

var rendererKS = new THREE.WebGLRenderer( { alpha: true });
rendererKS.setSize(wi,he);
var domel=rendererKS.domElement;
slide.appendChild(domel);
setStyle(domel,{ "position":"absolute", "left":"50px", "bottom":"50px"})

var sliderKS=document.getElementById("slider1");
sliderKS.value=sliderKS.max;

var controlsKS = new THREE.OrbitControls( cameraKS, domel );
    controlsKS.target.set( 0, 0, 0 );
    controlsKS.enableKeys=false;
    controlsKS.update();
/*
controlsKS.rotateSpeed = 1.0;
controlsKS.zoomSpeed = 1.2;
controlsKS.panSpeed = 0.8;
controlsKS.noZoom = false;
controlsKS.noPan = false;
controlsKS.staticMoving = true;
controlsKS.addEventListener( 'change', render );      
*/
var planeKS = new THREE.Plane( new THREE.Vector3( 0, 0, 1 ), 10.0 );
rendererKS.localClippingEnabled = true;

var dirLightKS1 = new THREE.DirectionalLight( 0xFFFFDD, 0.6 );
var dirLightKS2 = new THREE.DirectionalLight( 0xFFDDFF, 0.6 );
dirLightKS1.position.set( 2, 3, 5 );
dirLightKS2.position.set( -1, -4, -4 );
dirLightKS1.castShadow = false;
dirLightKS2.castShadow = false;
sceneKS.add( dirLightKS1 );
sceneKS.add( dirLightKS2 );
      
var ambLight = new THREE.AmbientLight( 0xFFFFFF, 0.4 );
sceneKS.add( ambLight );

var tau=2*Math.PI;

var meshKS = new THREE.Geometry();
var NB1=30;
var NB2=60;
for(var i=0; i<=NB1; i++) {
  var s=i/NB1;
  for(var j=0; j<=NB2; j++) {
    var t=j/NB2;
    t=0.9*(2*t-1);
    var x=2*(t*t-0.5)-1.2*(1-s)*(1-s);
    var y=3*(t*t*t-t/3);
    var z=2*s-1;
    meshKS.vertices.push(new THREE.Vector3(x,y,z));
  }
}

var offset=0;
var ksgap=0.3;

offset=mesh_push_rect(meshKS,NB1,NB2,offset);

for(var i=0; i<=NB1; i++) {
  var s=i/NB1;
  s=1-s;
  for(var j=0; j<=NB2; j++) {
    var t=j/NB2;
    t=0.9*(2*t-1);
    var u=4*t;
    var v=9*t*t-1;
    var d=Math.sqrt(u*u+v*v);
    var x=2*(t*t-0.5)+1.2*(1-s)*(1-s)+ksgap*v/d;
    var y=3*(t*t*t-t/3)-ksgap*u/d;
    var z=2*s-1;
    meshKS.vertices.push(new THREE.Vector3(x,y,z));
  }
}

offset=mesh_push_rect(meshKS,NB1,NB2,offset);

var NB3=16;

for(var i=0; i<=NB3; i++) {
  var s=i/NB3;
  s=1-s;
  var co=Math.cos(s*tau/2);
  var si=Math.sin(s*tau/2);
  for(var j=0; j<=NB2; j++) {
    var t=j/NB2;
    t=0.9*(2*t-1);
    var u=4*t;
    var v=9*t*t-1;
    var d=Math.sqrt(u*u+v*v);
    var x=2*(t*t-0.5)+ksgap*v/d*(1+co)/2;
    var y=3*(t*t*t-t/3)-ksgap*u/d*(1+co)/2;
    var z=1+ksgap*si/2;
    meshKS.vertices.push(new THREE.Vector3(x,y,z));
  }
}

offset=mesh_push_rect(meshKS,NB3,NB2,offset);

meshKS.computeVertexNormals();

var material = new THREE.MeshLambertMaterial( {
          color: 0x80ee10,
          
          side: THREE.BackSide,

          // ***** Clipping setup (material): *****
          clippingPlanes: [ planeKS ],
//						clipShadows: true

        } );
var material2 = new THREE.MeshLambertMaterial( {
          color: 0xee8010,
          
          side: THREE.FrontSide,

          // ***** Clipping setup (material): *****
          clippingPlanes: [ planeKS ],
//						clipShadows: true

        } );
var keyShape = new THREE.Mesh( meshKS, material );
sceneKS.add( keyShape );
var keyShape_in = new THREE.Mesh( meshKS, material2 );
sceneKS.add( keyShape_in );

//  keyShape.rotateX( -Math.PI / 2);
//  keyShape_in.rotateX( -Math.PI / 2);
  
var stopRenderKS=false;

var timeKS=0;

var renderKS = function () {
  if(!stopRenderKS) requestAnimationFrame( renderKS );

  if(animateKS)
    timeKS+=1/60;
  else 
    timeKS=0;
  var h=Math.sin(timeKS);

  if(cutKS) {
    
    /*var phi=-(tau/4-controlsKS.getPolarAngle());
    var theta=controlsKS.getAzimuthalAngle()+tau/4;
    
    planeKS.normal.x=Math.cos(phi)*Math.cos(theta);
    planeKS.normal.y=Math.cos(phi)*Math.sin(theta);
    planeKS.normal.z=Math.sin(phi);*/
    var t=sliderKS.value/sliderKS.max;
    t=2*t-1;
    t=2*t;
    planeKS.constant=t;

  }
  else
    planeKS.constant=10.;
  
  var h0=0.2;
  
  v=meshKS.vertices; 
  var offset=0;
  for(var i=0; i<=NB1; i++) {
    var s=i/NB1;
    for(var j=0; j<=NB2; j++) {
      var t=j/NB2;
      t=0.9*(2*t-1);
      v[offset+i*(NB2+1)+j].setZ(2*s-1+h0*t*h);
    }
  }
  offset += (NB1+1)*(NB2+1);
  for(var i=0; i<=NB1; i++) {
    var s=i/NB1;
    s=1-s;
    for(var j=0; j<=NB2; j++) {
      var t=j/NB2;
      t=0.9*(2*t-1);
      v[offset+i*(NB2+1)+j].setZ(2*s-1+h0*t*h);
    }
  }
  offset += (NB1+1)*(NB2+1);
  for(var i=0; i<=NB3; i++) {
    var s=i/NB3;
    s=1-s;
    var si=Math.sin(s*tau/2);
    for(var j=0; j<=NB2; j++) {
      var t=j/NB2;
      t=0.9*(2*t-1);
      v[offset+i*(NB2+1)+j].setZ(1+h0*t*h+ksgap*si/2);
    }
  }
  meshKS.computeVertexNormals();
  meshKS.verticesNeedUpdate=true;
  
  rendererKS.render(sceneKS, cameraKS);
};

var slideKSEnter = function() {
  stopRenderKS=false;
  renderKS();
}
var slideKSLeave = function() {
  stopRenderKS=true;
}
slide.addEventListener("impress:stepenter",slideKSEnter,false);
slide.addEventListener("impress:stepleave",slideKSLeave,false);
}