function WG1b() {
var tau=2*Math.PI;
var SCALE=100;
var OFF = {x:-100, y:-30};

var v0 = {x:0,y:0};

var norm=function(v) {
  return(Math.sqrt(v.x*v.x+v.y*v.y));
}
function g(a) {
  var t=a*tau;
  var c=Math.cos(t);
  var s=Math.sin(t);
  return({
    x: (c-c*c*0.6-c*c*c*0.4)+0.5
   ,y: (s-3*s*(2*c*c-1))/5
  });
}
function dg(a) {
  var t=a*tau;
  var c=Math.cos(t);
  var s=Math.sin(t);
  return({
    x: tau*(-s+2*s*c*0.6+3*s*c*c*0.4)
   ,y: tau*(c-3*(c-2*3*c*s*s))/5
  });
}
function mp(p) {
  return {
    x: canvas.width/2   + SCALE*p.x + OFF.x
   ,y: canvas.height/2  - SCALE*p.y + OFF.y
  };
}
function vp(v) {
 return ({x: v.x*SCALE, y:-v.y*SCALE});
}

var curve1=[];
var dir1=[];
var spd=0.005;
var sur=5;
var k=0;
for(var t=0; t<1; ) {
  var p=g(t);
  if(k==0) curve1.push(p)
  k = (k+1) % sur;
  t += (spd/sur)/norm(dg(t));
}
var N1=curve1.length;
var aux=0;
var v={x:0,y:1};
for(var i=0; i<N1; i++) {
  var q=curve1[i];
  var p=curve1[(i+1)%N1];
  var nv={x:p.x-q.x, y:p.y-q.y};
  var r=norm(nv);
  aux += Math.atan2(nv.y*v.x-nv.x*v.y,nv.x*v.x+nv.y*v.y);
  dir1.push({x:r, y:aux});
  v=nv;
}

var curve2=[];
var dir2=[];
var r=N1*spd/tau;
for(var i=0; i<N1; i++) {
  var t=i/N1*tau;
  curve2.push({x:Math.cos(t+tau/2)*r, y:Math.sin(t+tau/2)*r});
}
aux=0;
v={x:0,y:1};
for(var i=0; i<N1; i++) {
  var q=curve2[i];
  var p=curve2[(i+1)%N1];
  var nv={x:p.x-q.x, y:p.y-q.y};
  var r=norm(nv);
  aux += Math.atan2(nv.y*v.x-nv.x*v.y,nv.x*v.x+nv.y*v.y);
  var temp={x:r, y:aux};
  dir2.push({x:r, y:aux});
  v=nv;
}


var canvas=document.getElementById("canvasWGFaux");
var ctx=canvas.getContext("2d");
var curve=[];
function WG() {
  var t=slider.value/slider.max;
  var w=slider2.value/slider2.max;

  var a=(1-t)*dir1[0].y+t*dir2[0].y;
  var r=(1-t)*dir1[0].x+t*dir2[0].x;
  var v00 = {x: r*Math.cos(a)*N1, y:r*Math.sin(a)*N1 };
//  var a=(1-t)*dir1[N1-1].y+t*dir2[N1-1].y;
//  var r=(1-t)*dir1[N1-1].x+t*dir2[N1-1].x;
//  var v01 = {x: r*Math.cos(a)*N1, y:r*Math.sin(a)*N1 };
//  v0 = {x:(v00.x+v01.x)/2, y:(v00.y+v01.y)/2};
  v0=v00;
  
  var x=0,y=0;
  curve=[{x:x,y:y}];
  for(var i=1; i<N1; i++) {
    var a=(1-t)*dir1[i].y+t*dir2[i].y;
    var r=(1-t)*dir1[i].x+t*dir2[i].x;
    x += r*Math.cos(a);
    y += r*Math.sin(a);
    curve.push({x:x,y:y});
  }
//  var bx=0,by=0;
  for(var i=1; i<N1; i++) {
    var s=i/N1;
    curve[i].x -= w*s*x;
    curve[i].y -= w*s*y;
//    bx += curve[i].x;
//    by += curve[i].y;
  }
  v0.x -= w*x;
  v0.y -= w*y;
  /*
  bx /= N1;
  by /= N1;
  for(var i=0; i<N1; i++) {
    var s=i/N1;
    curve[i].x -= bx;
    curve[i].y -= by;
  }*/
}

var draw_vect=function(p,v) {
  var d=vp(v);
  var m=mp(p);
  for(var i=0; i<2; i++) {
    ctx.beginPath();
    ctx.moveTo(m.x,m.y);
    ctx.lineTo(m.x+d.x,m.y+d.y);
    ctx.moveTo(m.x+d.x*0.8-d.y*0.15,m.y+d.y*0.8+d.x*0.15);
    ctx.lineTo(m.x+d.x,m.y+d.y);
    ctx.lineTo(m.x+d.x*0.8+d.y*0.15,m.y+d.y*0.8-d.x*0.15);
    ctx.stroke();
    ctx.beginPath();
    ctx.arc(m.x,m.y,5,0,tau);
    ctx.fill();
  }
}

var draw=function() {
  WG();
  ctx.clearRect(0,0,canvas.width,canvas.height);
  ctx.fillStyle="red";
  ctx.strokeStyle="red";
  var v1 = { x:v0.x/10, y:0*v0.y/10};
  draw_vect(curve[0],v1);
  draw_vect(curve[N1-1],v1);
/*  ctx.beginPath();
  var aux=mp(curve[0]);
  ctx.arc(aux.x,aux.y,5,0,360);
  ctx.fill();
  
  ctx.beginPath();
  var aux=mp(curve[N1-1]);
  ctx.arc(aux.x,aux.y,5,0,360);
  ctx.fill();*/
  
  ctx.strokeStyle="black";
  ctx.lineWidth=2;
  ctx.beginPath();
  var m=mp(curve[0]);
  ctx.moveTo(m.x,m.y);
  for(var i=1; i<N1; i++) {
    m=mp(curve[i]);
    ctx.lineTo(m.x,m.y);
  }
  ctx.stroke();
}

var slider=document.getElementById("sliderWGFaux");
slider.value=0;
slider.oninput=draw;
var slider2=document.getElementById("sliderWGFaux2");
slider2.value=0;
slider2.oninput=draw;

WG();
draw();
}